package Profits::Controller::Users;

use Mojo::Base 'Mojolicious::Controller';
use feature 'signatures';
no warnings qw{ experimental::signatures };

sub list ($c) {
    $c->openapi->valid_input or return;
    my $args = $c->validation->output;

    my ($cond, $attrs) = $c->search_parametrs( $args );

    $cond->{is_active} = 1;

    if ( $args->{search} ) {
        my $search = { -ilike => '%' . $args->{search} . '%' };

        $cond->{-or} = [
            displayname => $search,
            username    => $search,
        ];
    }

    my @users = ();
    my $count = $c->schema->resultset('User')->count($cond);

    if ( $count ) {
        my $users = $c->schema->resultset('User')->search($cond, $attrs);

        USER:
        while ( my $user = $users->next() ) {
            my $formatted = { $user->get_columns() };
            push @users, $c->spec_filter($formatted, 'User');
        }
    }

    $c->render(json => {
        data  => \@users,
        total => $count,
    });
}

1;
