package Profits::Schema::Result::User;

use strict;
use warnings;

use base 'DBIx::Class::Core';

our $VERSION = 1;

__PACKAGE__->table('users');

__PACKAGE__->add_columns(
    id => {
        data_type         => 'integer',
        is_auto_increment => 1,
        is_nullable       => 0,
        sequence          => 'uid_seq'
    },
    qw(
        uuid
        octid
        username
        is_active
        displayname
        notes
        properties
    ),
);

__PACKAGE__->set_primary_key('id');

__PACKAGE__->add_unique_constraint(
    'uuid' => [qw(uuid)]
);

__PACKAGE__->add_unique_constraint(
    'octid' => [qw(octid)]
);

__PACKAGE__->add_unique_constraint(
    'username' => [qw(username)]
);

#__PACKAGE__->inflate_column('properties', {
#    inflate => sub {
#        return [ split /\W+/, shift ];
#    },
#});

1;
